#!/usr/bin/env python
# -*- coding: utf-8; py-indent-offset:4 -*-
###############################################################################
#
#  Copyright (C) 2016 Daniel Rodriguez
#
#  This program is free software: you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation, either version 3 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
###############################################################################
"""Subclass of MainFrame, which is generated by wxFormBuilder."""
import os.path
import time

import wx

import maingui
import models.mainmodel as mainmodel
from utils.mvc import DynamicClass

import utils.wxfb as wxfb


# Implementing MainFrame
# @WidgetBindings
@DynamicClass(moddirs=['views', 'controllers'])
class MainFrame(maingui.MainFrame):
    def __init__(self, parent):
        maingui.MainFrame.__init__(self, parent)

        wxfb.BindingFilePicker('fileread')
        wxfb.BindingCheckBox('loadlast', default=True)

        wxfb.BindingButton('recalculate')
        wxfb.BindingButton('save')
        wxfb.BindingButton('saveas')

        wxfb.BindingTextCtrl('crcold', config=False)
        wxfb.BindingTextCtrl('crcnew', config=False)

        self.model = mainmodel.MainModel()
        if self.loadlast.value and self.fileread.path:
            if os.path.isfile(self.fileread.path):
                self.model.load(self.fileread.path)

        # time.sleep(1.0)

    # With tuple in the name we can define a "config" path for the variable
